#include "appConfig.h"
#include <rs232.h>
#include <macros.h>

void rs232_init()
{
	TRISC |= 0b10000000 ; // set bit 7 (input)
	// setbit(TRISC,7) ;
	TRISC &= 0b10111111 ;  // clear bit 6 (output)
	// clrbit(TRISC,6) ;
	
	//  0b00100100 ; // tx enabled, hi speed
	TXSTA =  BIT(TXEN) | BIT(BRGH) ; 
	
	// 0b10010000 ; // serial port enabled, 8 bits,
	// continuous rx enabled, no it
	RCSTA =  BIT(SPEN) | BIT(CREN) ;  
	
	// 9600 bds, hi speed@16Mhz, p200
	SPBRG =  103 ; 
	// clear PIE1<4> = disable transmit it	
	// clear PIE1<5> = disable receive it
	PIE1 &=  0b11001111 ; 
}

void rs232_putchar(char c)
{
	if( c == '\n' ) // LF -> CR-LF
	{
		while( !(PIR1 & 0b00010000) ) ; // wait for TXREG empty
		TXREG = '\r'  ;
		NOP ; NOP ; // because TXREG needs 2 instr to be valid	
	}
	while( !(PIR1 & 0b00010000) ) ; // wait for TXREG empty
	TXREG = c ;	
}
// blocking rs232 read
char rs232_getchar()
{
	if( RCSTA & 4) // framing error ?
		PRODH = RCREG ; // clear it by reading RCREG
	if( RCSTA & 2) // overrun error ?
		RCSTA &= ~0b00010000 ;	// clear bit CREN
		
	RCSTA |= 0b00010000 ;
	while( !( PIR1 & 0b00100000) ) ; // wait for RCREG full
	return RCREG ;
}
